unit LResources;

{*******************************************************}
{                                                       }
{       Light Windows                                   }
{       Resources                                       }
{                                                       }
{       2000..2004 YT                                   }
{                                                       }
{*******************************************************}

interface

uses
	Windows, Messages, SysUtils,
	LObjects, LConsts, LStreams;

type
	//\[X
	TResourceStream = class(T0MemoryStream)
	private
		HResInfo: HRSRC;
		HGlobal: THandle;
	public
		constructor Create(Instance: THandle; ResName, ResType: PChar);
		destructor Destroy; override;
	end;

type
	EResNotFound = class(Exception);

implementation

{ TResourceStream }

constructor TResourceStream.Create(Instance: THandle; ResName, ResType: PChar);
label
	Error; //BASIC G[
begin
	inherited Create;

	HResInfo := FindResource(Instance, ResName, ResType);
	if HResInfo = 0 then goto Error;
	HGlobal := LoadResource(Instance, HResInfo);
	if HGlobal = 0 then goto Error;
	SetPointer(LockResource(HGlobal), SizeOfResource(Instance, HResInfo));
Exit;
Error:
	raise EResNotFound.CreateFmt(SResNotFound, [ResName]);
end;

destructor TResourceStream.Destroy; {override}
begin
	UnlockResource(HGlobal);
	FreeResource(HGlobal);

	inherited;
end;

end.

