unit LScrSaver;

{*******************************************************}
{                                                       }
{       Light Windows                                   }
{       Screen Saver Framework                          }
{                                                       }
{       2000..2004 YT                                   }
{                                                       }
{*******************************************************}

(*

	CvOɎ̎w߂

		{$E scr}
		{$D SCRNSAVE:}

	T0ScreenSaver, T0ScreenSaverWindow炻ꂼh
	Kpɉă_CAO{bNX

	AvP[V

procedure TApplication.Initialize;
begin
	inherited Initialize(TMainThread.Create);

	case Mode of
	ssPreview, ssScreenSaver:
		TScreenSaverWindow.Create(Parent, Mode = ssPreview).Owner := Self;
	ssPassword:
		{$IFDEF WIN9X} ProcessChangePassword(0) {$ENDIF} ;
	else
		MessageBoxW(0, 'No setting items.', PWideChar(Title), MB_OK);
	end;
end;

	*.scrC:\WINNT\System32ɃRs[

2002-07-14
	SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0/1, nil, 0) ߂
	9xnIFDEF WIN9Xň͂Đ؂̂

*)

interface

uses
	Windows, Messages, SysUtils,
	LConsts, LObjects, LWindows, LRegistry;

type
	T0ScreenSaverWindow = class(T0MainWindow)
	private
		FCurPos: TPoint;
		FHasCurPos: Boolean;
		FIsPreview: Boolean;
{$IFDEF WIN9X}
		FInputingPassword: Boolean;
{$ENDIF}
		procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
		procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
		procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
		procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
		procedure WMSetCursor(var Msg: TWMSetCursor); message WM_SETCURSOR;
		procedure WMClose(var Msg: TWMClose); message WM_CLOSE;
	protected
		function CloseQuery: Boolean; override;
		procedure Setup; override;
		class function WndClassName: string; override;
		class procedure CreateClass(var WndClass: tagWNDCLASSEXW); override;
		function KeyInput(Code: WideChar): Boolean; override;
	public
		constructor Create(AParent: T0Wnd; APreview: Boolean);
		property IsPreview: Boolean read FIsPreview;
	end;

type
	TScreenSaverMode = (ssNone,
					ssCustomize, ssPassword, ssPreview, ssScreenSaver);

	T0ScreenSaver = class(T0Application)
	private
		FParent: T0Wnd;
		FMode: TScreenSaverMode;
	protected
		procedure Initialize(AMainThread: TMainThread); overload;
	public
		property Parent: T0Wnd read FParent;
		property Mode: TScreenSaverMode read FMode;
	end;

const
	ScreenSaverClassName = 'WindowsScreenSaverClass';

{$IFDEF WIN9X}
function UsingScreenSavePassword: Boolean;
function VerifyScreenSavePassword(ParentWnd: HWND): Boolean;
procedure ProcessChangePassword(ParentWnd: HWND);
{$ENDIF}

implementation

{ T0ScreenSaverWindow }

constructor T0ScreenSaverWindow.Create(AParent: T0Wnd; APreview: Boolean);
var
	CS: PCreateStructW;
	CSize: TSize;
begin
	inherited Create('', ZeroPoint, ZeroSize);

	FIsPreview:= APreview;

	//FXƃX^CȂ񂩂
	CS := CreateStruct;

	CS^.Style:= CS.Style and not WS_OVERLAPPEDWINDOW;
	CS^.lpszClass:= ScreenSaverClassName;

	if not IsPreview then
	begin
		CS.Style:= CS.Style or Integer(WS_POPUP);
		CS.dwExStyle:= CS.dwExStyle or WS_EX_TOPMOST;
	end
	else
	begin
		ShowWindow(AParent.Handle, SW_SHOW);
		CS.hwndParent:= AParent.Handle;
		CS.Style:= CS.Style or WS_CHILD;
		CSize:= AParent.ClientSize;
		CS^.CX:= CSize.CX;
		CS^.CY:= CSize.CY;
	end;
end;

function T0ScreenSaverWindow.CloseQuery: Boolean; {override}
begin
{$IFDEF WIN9X}
	// NT ܂ vr[ȂfɏI
	if (Win32Platform = VER_PLATFORM_WIN32_NT) or IsPreview then
	begin
		Result := True;
		Exit;
	end;

	//9xȂpX[hƊi
	if FInputingPassword then
	begin
		Result:= False;
		Exit;
	end;

	FInputingPassword:= True;

	if UsingScreenSavePassword then
		Result:= VerifyScreenSavePassword(Handle)
	else
		Result:= True;

	FInputingPassword:= False;
	FHasCurPos:= False;
{$ELSE}
	Result := True
{$ENDIF}
end;

procedure T0ScreenSaverWindow.WMLButtonUp(var Message: TWMLButtonUp); {message}
begin
	if not IsPreview then Close;
end;

procedure T0ScreenSaverWindow.WMRButtonUp(var Message: TWMRButtonUp); {message}
begin
	if not IsPreview then Close;
end;

procedure T0ScreenSaverWindow.WMMouseMove(var Message: TWMMouseMove); {message}
var
	StepX, StepY: Integer;
begin
	if not IsPreview then
	begin
		if not FHasCurPos then
		begin
			FCurPos.X:= Message.XPos;
			FCurPos.Y:= Message.YPos;
			FHasCurPos:= True;
			Exit;
		end;

		StepX:= Abs(FCurPos.X - Message.XPos);
		StepY:= Abs(FCurPos.Y - Message.YPos);
		if StepX * StepX + StepY * StepY > 100 then
			Close;
	end;
end;

procedure T0ScreenSaverWindow.WMSysCommand(var Msg: TWMSysCommand);
begin
	if (Msg.CmdType and $FFF0) = SC_SCREENSAVE then
		Msg.Result := 0
	else
		inherited;
end;

procedure T0ScreenSaverWindow.WMSetCursor(var Msg: TWMSetCursor); {message}
begin
	Windows.SetCursor(0);
end;

class function T0ScreenSaverWindow.WndClassName: string;
begin
	Result := ScreenSaverClassName
end;

procedure T0ScreenSaverWindow.Setup;
const
	Cmd: array[Boolean] of Integer = (SW_SHOWMAXIMIZED, SW_SHOW);
begin
	ShowWindow(Handle, Cmd[IsPreview]);
end;

class procedure T0ScreenSaverWindow.CreateClass(var WndClass: tagWNDCLASSEXW);
begin
	inherited;
	WndClass.hbrBackground := GetStockObject(BLACK_BRUSH)
end;

procedure T0ScreenSaverWindow.WMClose(var Msg: TWMClose);
begin
	inherited;
	ShowWindow(Handle, SW_HIDE);

{$IFDEF WIN9X}
	if Terminated and IsPreview and (Win32Platform = VER_PLATFORM_WIN32_NT) then
{$ELSE}
	if Terminated and IsPreview then
{$ENDIF}
	begin
		Free; {̂ŕȂƐ؂ւłȂ}
		Halt; {̂ŏIȂƃvZXc}
	end
end;

function T0ScreenSaverWindow.KeyInput(Code: WideChar): Boolean;
begin
	Close;
	Result := True;
end;

{ T0ScreenSaver }

procedure T0ScreenSaver.Initialize(AMainThread: TMainThread);
var
	I, Err: Integer;
	Param, ParentParam: String;
	ParentWnd: HWND;
	S: PChar;
begin
	inherited Initialize(AMainThread);

	FMode := ssNone;

	for I:= 1 to ParamCount do
	begin
		Param:= ParamStr(I);
		S:= PChar(Param);

		if (S^ in ['-', '/']) and ((S + 1)^ <> #0) and ((S + 2)^ in [#0, ':']) then
		begin
			case (S + 1)^ of
			'c', 'C'          : FMode:= ssCustomize;
			'p', 'P', 'l', 'L': FMode:= ssPreview;
			'a', 'A'          : FMode:= ssPassword;
			's', 'S'          : FMode:= ssScreenSaver;
			else Continue;
			end;

			if (S + 2)^ = ':' then
				ParentParam:= Copy(Param, 4, 999)
			else
				ParentParam:= ParamStr(I + 1);

			Val(Trim(ParentParam), ParentWnd, Err);

			if (Err = 0) and IsWindow(ParentWnd) then
				FParent:= TExternalWindow.Create(ParentWnd);

			Break;
		end;
	end;

	if FParent = nil then
	begin
		FParent := TExternalWindow.Create(GetDesktopWindow);
		FParent.Owner := Self
	end
end;

function UsingScreenSavePassword: Boolean;
var
	Hive: TRegistryHive;
	Key: TRegistryKey;
begin
	try
		Hive := nil;
		Key := nil;
		try
			Hive := TRegistryHive.Create(HKEY_CURRENT_USER);
			Key := TRegistryKey.Create(Hive, 'Control Panel\Desktop');

			Result := Key.ReadInteger('ScreenSaveUsePassword') <> 0
		finally
			Key.Free;
			Hive.Free;
		end;
	except
		Result := False
	end
end;

function VerifyScreenSavePassword(ParentWnd: HWND): Boolean;
const
	DllName = 'PASSWORD.CPL';
	ProcName = 'VerifyScreenSavePwd';
var
	VerifyScreenSavePwd: function(ParentWnd: HWND): BOOL; stdcall;
	Lib: THandle;
begin
	Result:= True;
	try
		Lib:= LoadLibraryW(DllName);
		if Lib = 0 then
			raise Exception.CreateFmt(SDLLNotFound, [DllName]);

		try
			@VerifyScreenSavePwd:= GetProcAddress(Lib, ProcName);
			if @VerifyScreenSavePwd = Nil then
				raise Exception.CreateFmt(SProcNotFound, [DllName, ProcName]);

			Result:= VerifyScreenSavePwd(ParentWnd);
		finally
			FreeLibrary(Lib);
		end;
	except
	on E: Exception do
		MessageBoxW(ParentWnd, PWideChar(WideString(E.Message)),
						PWideChar(Application.Title), MB_ICONWARNING);
	end;
end;

procedure ProcessChangePassword(ParentWnd: HWND);
const
	DllName = 'MPR.DLL';
	ProcName = 'PwdChangePasswordA';
var
	PwdChangePasswordA: procedure(Caption: PAnsiChar;
					ParentWnd: HWND; Param1, Param2: UINT); stdcall;
	Lib: THandle;
begin
	try
		Lib:= LoadLibraryW(DllName);
		if Lib = 0 then
			raise Exception.CreateFmt(SDLLNotFound, [DllName]);

		try
			@PwdChangePasswordA:= GetProcAddress(Lib, ProcName);
			if @PwdChangePasswordA = Nil then
				raise Exception.CreateFmt(SProcNotFound, [DllName, ProcName]);

			PwdChangePasswordA('SCRSAVE', ParentWnd, 0, 0);
		finally
			FreeLibrary(Lib);
		end;
	except
	on E: Exception do
		MessageBoxW(ParentWnd, PWideChar(WideString(E.Message)),
						PWideChar(Application.Title), MB_ICONWARNING);
	end;
end;

end.

